 <?php
require __DIR__."/vendor/autoload.php";
require __DIR__."/vendor/zeedhi/framework/bootstrap.php";
require __DIR__."/vendor/teknisa/libraries/scripts/bootstrap.php";

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$db = __DIR__.'/../../../backend/config/db.xml';
$general = __DIR__.'/../../../backend/config/general.xml';
$environment = __DIR__.'/config/environment.xml';
$environmentProd = __DIR__.'/../../../backend/config/environment.xml';
$parameters      = __DIR__.'/config/parameters.xml';
$parametersProd = __DIR__.'/../../../backend/config/parameters.xml';
$report = __DIR__.'/config/report.xml';
$zhulog = __DIR__.'/vendor/zeedhi/zhulog/config/log.xml';

$preferences     = __DIR__.'/vendor/zeedhi/preferences/services.xml';
$preferencesConfig = __DIR__.'/config/preferences.xml';

if(!realpath($db)) {
    $db = __DIR__."/config/db.xml";
}

$routes = array();
$routes[] = __DIR__.'/vendor/teknisa/libraries/libRoutes.json';

$mapping = file_get_contents(__DIR__.'/config/servicesMapping.json');
$mapping = json_decode($mapping, true);
foreach ($mapping as $path) {
    $ext = substr(strrchr($path,'.'),1);
    if($ext === 'xml')
        $instanceManager->loadFromFile(__DIR__.$path);
    if($ext === 'json')
        $routes[] = __DIR__.$path;
}

$instanceManager->loadFromFile($db);
$instanceManager->loadFromFile($general);
$instanceManager->loadFromFile($report);
$instanceManager->loadFromFile($parametersProd);
$instanceManager->loadFromFile($parameters);
$instanceManager->loadFromFile($environmentProd);
$instanceManager->loadFromFile($environment);
$instanceManager->loadFromFile($preferences);
$instanceManager->loadFromFile($preferencesConfig);

$container = $instanceManager->getContainer();

if ($container->hasParameter('use_zhu_acl') && $container->getParameter('use_zhu_acl') == 'true'){
    $acl = __DIR__ . '/../../acl/backend/config/acl.xml';
    
    if(realpath($acl)) 
        $instanceManager->loadFromFile($acl);
    
    require __DIR__ . "/vendor/zeedhi/zhuaclbackend/service/bootstrap.php";
    $routes[] = __DIR__ . "/vendor/zeedhi/zhuaclbackend/config/routes.json";
}

if ($container->hasParameter('use_zhu_update') && $container->getParameter('use_zhu_update') == 'true'){
    $zhu = __DIR__ . '/../../acl/backend/config/zhuUpdate.xml';

    if(realpath($zhu))
        $instanceManager->loadFromFile($zhu);
}

if ($container->hasParameter('use_zhu_log') && $container->getParameter('use_zhu_log') == 'true') {
    if(realpath($zhulog))
        $instanceManager->loadFromFile($zhulog);
    
    $zhuLogDateFormat = $container->getParameter('zhuLogDateFormat');
    
    require __DIR__."/vendor/zeedhi/zhulog/config/bootstrap.php";
    
    $container->setParameter('zhuLogDateFormat', $zhuLogDateFormat);
}

$routes[] = __DIR__ . "/vendor/zeedhi/preferences/routes.json";

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));

$instanceManager->compile();

$entity_manager = $instanceManager->getService('entityManager');
\Setforms2\Shared\Registry::store("EntityManager", $entity_manager);
\Setforms2\Shared\Registry::store("EntityManagerConnection", $entity_manager->getConnection());